<?php
/*

MIT License (MIT)

Copyright (c) 2013 http://coinwidget.com/
Copyright (c) 2013 http://scotty.cc/
Copyright (c) 2014 http://www.alvinhkh.com/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

header("Content-type: text/javascript");
/*
	you should server side cache this response, especially if your site is active
*/
$data = isset($_GET['data'])?$_GET['data']:'';
if (!empty($data)) {
	$data = explode("|", $data);
	$responses = array();
	if (!empty($data)) {
		foreach ($data as $key) {
			list($instance,$currency,$address) = explode('_',$key);
			switch ($currency) {
				case 'bitcoin':
					$response = get_bitcoin($address);
					break;
				case 'litecoin':
					$response = get_litecoin($address);
					break;
				case 'dogecoin':
					$response = get_dogecoin($address);
					break;
				}
				$responses[$instance] = $response;
			}
		}
		echo 'var COINWIDGETCOM_DATA = '.json_encode($responses).';';
	}

function get_bitcoin($address) {
	$return = array();
	$data = get_request('http://blockchain.info/address/'.$address.'?format=json&limit=0');
	if (!empty($data)) {
		$data = json_decode($data);
		$return += array(
			'count' => (int) $data->n_tx,
			'amount' => (float) $data->total_received/100000000
		);
		return $return;
	}
}

function get_litecoin($address) {
	$return = array();
	$data = get_request('http://explorer.litecoin.net/address/'.$address);
	if (!empty($data)
	  && preg_match("/Transactions in: (.*)/", $data, $count)
	  && preg_match("/Received: (.*) LTC/", $data, $amount)) {
	  	$return += array(
			'count' => (int) $count[1],
			'amount' => (float) $amount[1]
		);
	  	return $return;
	}
}

function get_dogecoin($address) {
	$return = array();
	$data = get_request('http://dogechain.info/address/'.$address);
	if (!empty($data)
	  && preg_match("/Transactions received<\/td>\s+<td><span class=\"number\">(.*)<\/span>/", $data, $count)
	  && preg_match("/Received<\/td>\s+<td><span class=\"currency\">(.*)<\/span>/", $data, $amount)) {
	  	$return += array(
			'count' => (int) $count[1],
			'amount' => (float) $amount[1]
		);
	  	return $return;
	}
}

function get_request($url,$timeout=4) {
	if (function_exists('curl_version')) {
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, $timeout);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($curl, CURLOPT_USERAGENT,'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13');
		$return = curl_exec($curl);
		curl_close($curl);
		return $return;
	} else {
		return @file_get_contents($url);
	}
}

function parse($string,$start,$stop) {
	if (!strstr($string, $start)) return;
	if (!strstr($string, $stop)) return;
	$string = substr($string, strpos($string,$start)+strlen($start));
	$string = substr($string, 0, strpos($string,$stop));
	return $string;
}

?>